%% script1



%%

clear
close all
load cpts  % contains cpts1 and cpts2
load mpts  % contains mpts1 and mpts2
load CalibResults

%%

figure(1);
rgb1 = imread(files{1});
show_points(rgb1,cpts1);
title([int2str(size(cpts1,1)) ' points']);

figure(2);
rgb2 = imread(files{2});
show_points(rgb2,cpts2);
title([int2str(size(cpts2,1)) ' points']);


%%

worldPoints = [ 0 0; 21 0; 21 21; 0 21];

[R1, T1] = extrinsics(cpts1(1:4,:),worldPoints,cameraParams)

[R2, T2] = extrinsics(cpts2(1:4,:),worldPoints,cameraParams)


%%


[F, inliersIndex] = estimateFundamentalMatrix(mpts1,mpts2);
format shortg
F
format
inliersIndex'

% Fundamental matrix should be rank 2
fprintf('rank(F) = %d\n',rank(F));


%%


%   mpts2 * F * mpts1' = 0;

clear dev
npts = size(mpts1,1);

for k = 1:npts
    dev(k) = [mpts2(k,1:2) 1]*F*[mpts1(k,1:2) 1]';
end

ndx = 1:npts;
[ndx' inliersIndex dev']



%%

% function d = computeDistance(disType, pts1h, pts2h, f)
% pfp = (pts2h' * f)';
% pfp = pfp .* pts1h;
% d = sum(pfp, 1) .^ 2;
% 
% if strcmp(disType, 'sampson')
%   epl1 = f * pts1h;
%   epl2 = f' * pts2h;
%   d = d ./ (epl1(1,:).^2 + epl1(2,:).^2 + epl2(1,:).^2 + epl2(2,:).^2);
% end

k=5;
pts1h = [mpts1(k,1:2) 1]';
pts2h = [mpts2(k,1:2) 1]';
pfp = (pts2h' * F)'
pfp = pfp .* pts1h
d = sum(pfp,1).^2
fprintf('Quadratic distance %g\n',sqrt(d));

disType = 'sampson';
if strcmp(disType, 'sampson')
  epl1 = F * pts1h;
  epl2 = F' * pts2h;
  d = d ./ (epl1(1,:).^2 + epl1(2,:).^2 + epl2(1,:).^2 + epl2(2,:).^2);
  fprintf('Sampson distance %g\n',d)
end
fprintf('Our Deviation %g\n',dev(k))


%% 
% camera pose does not match results from extrinsics

[orientation,location] = cameraPose(F,cameraParams,mpts1,mpts2)

guess = R1*R2'

dt = T1-T2;
dt = dt/norm(dt)
