%% script4b

%%


clear
close all
load cpts
load mpts
load CalibResults
load Fmatrix

%% intrinsic matrix

fc = cameraParams.FocalLength;
cc = cameraParams.PrincipalPoint;
K = [fc(1) 0 cc(1); 0 fc(2) cc(2); 0 0 1];
Kinv = inv(K);

%% extrinsic matrices

worldPoints = [ 0 0 ; 21 0 ; 21 21 ; 0 21 ];

[R1, T1] = extrinsics(cpts1(1:4,:),worldPoints,cameraParams)

[R2, T2] = extrinsics(cpts2(1:4,:),worldPoints,cameraParams)


%% verify basic equations

C1 = -T1*R1';
C2 = -T2*R2';

w = [worldPoints(1,:) 0];
c1 = w*R1+T1;
c1n = c1/c1(3)
img = K*c1n';
format shortg
img1 = img'/img(3)
cpts1(1,:)
format

% w1 = (c1n-T1)*R1'
w1 = c1n*R1' + C1;
xpts = [ C1; w1; w];

plot3(xpts(:,1),-xpts(:,2),-xpts(:,3),'ko--');
hold on
plot3(w(1),-w(2),-w(3),'ko');
hold off
axis equal
grid

c2 = w*R2+T2;
c2n = c2/c2(3)
w2 = (c2n-T2)*R2';
xpts = [ C2; w2; w];
hold on
plot3(xpts(:,1),-xpts(:,2),-xpts(:,3),'bo--');
hold off

%% calculate essential matrix

k1 = c1n*R1';
k2 = c2n*R2';

T = C2 - C1;
Sk = [0 -T(3) T(2); T(3) 0 -T(1); -T(2) T(1) 0];
cross1 = cross(T,k1)
cross2 = Sk*k1'
E = R2'*Sk*R1

test = c2n*E*c1n'

% dot1 = dot(k1,cross1)
% dot2 = dot(k2,cross1)

% cross3 = cross(k2,k1)
% dot3 = dot (cross3,T)

% xpts = [C1; C1+10*cross1/norm(cross1)];
% hold on
% plot3(xpts(:,1),-xpts(:,2),-xpts(:,3),'r');
% hold off

%% calculate fundamental matrix

x1 = c1n*K'
x2 = c2n*K'
Fc = inv(K')*E*inv(K);
Fc = Fc/Fc(3,3)
test2 = x2*Fc*x1'

%%

for n=1:4
    xa = [cpts1(n,:) 1];
    xb = [cpts2(n,:) 1];
    test = xb*Fc*xa';
    fprintf('%d %g\n',n,test);
end


%% recover camera parameters


E = R2'*Sk*R1
[U, S, V] = svd(E);
S
Ty = -U(:,3);
Tz = Ty*S(1)
T = R2'*(C2-C1)'
% norm(Tz)
W = [0 -1 0; 1 0 0; 0 0 1];
Rx = -U*W'*V'
Ry = U*W*V'
Rt = R2'*R1


%% compare to fitted F

test3 = x2*F*x1'

E2 = K'*F*K

[U, S, V] = svd(E2);
S
Tx = -U(:,3)
Ty % from before
% norm(Tx)
W = [0 -1 0; 1 0 0; 0 0 1];
Rx = U*W'*V'
Ry = -U*W*V'
% check if rotation matrix
% det(R)
% R*R'

%%

for n=1:4
    xa = [cpts1(n,:) 1];
    xb = [cpts2(n,:) 1];
    test = xb*F*xa';
    fprintf('%d %g\n',n,test);
end







