%% script4c

%%


clear
close all
load cpts
load mpts
load CalibResults
load Fmatrix

%% intrinsic matrix

fc = cameraParams.FocalLength;
cc = cameraParams.PrincipalPoint;
K = [fc(1) 0 cc(1); 0 fc(2) cc(2); 0 0 1];
Kinv = inv(K);

%% extrinsic matrices

worldPoints = [ 0 0 ; 21 0 ; 21 21 ; 0 21 ];

[R1, T1] = extrinsics(cpts1(1:4,:),worldPoints,cameraParams)

[R2, T2] = extrinsics(cpts2(1:4,:),worldPoints,cameraParams)


%% verify basic equations

C1 = -T1*R1';
C2 = -T2*R2';

w = [worldPoints(1,:) 0];
c1 = w*R1+T1;
c1n = c1/c1(3)

% w1 = (c1n-T1)*R1'
w1 = c1n*R1' + C1;


c2 = w*R2+T2;
c2n = c2/c2(3)
% w2 = (c2n-T2)*R2';
w2 = c2n*R2' + C2;

%% calculate essential matrix

% before (world reference)
% k1 = c1n*R1';
% k2 = c2n*R2'; 
% T = C2 - C1;

% now: image 2 reference
R = R1'*R2;
k1 = c1n*R;
k2 = c2n;
T = (C2 - C1)*R2;

Sk = [0 -T(3) T(2); T(3) 0 -T(1); -T(2) T(1) 0];
E = Sk*R'

test = c2n*E*c1n'

% dot1 = dot(k1,cross1)
% dot2 = dot(k2,cross1)

% cross3 = cross(k2,k1)
% dot3 = dot (cross3,T)

% xpts = [C1; C1+10*cross1/norm(cross1)];
% hold on
% plot3(xpts(:,1),-xpts(:,2),-xpts(:,3),'r');
% hold off

%% calculate fundamental matrix

x1 = c1n*K'
x2 = c2n*K'
Fc = inv(K')*E*inv(K);
Fc = Fc/Fc(3,3)
test2 = x2*Fc*x1'

%%

for n=1:4
    xa = [cpts1(n,:) 1];
    xb = [cpts2(n,:) 1];
    test = xb*Fc*xa';
    fprintf('%d %g\n',n,test);
end


%% recover camera parameters


[U, S, V] = svd(E);
S
Ty = U(:,3);
Tz = Ty*S(1)
T
% norm(Tz)
W = [0 -1 0; 1 0 0; 0 0 1];
Rx =  U*W'*V'
Ry = -U*W*V'
Rt = R'



