%% script7


%%

clear
close all
load filelist

img1 = rgb2gray(imread(files{1}));
img2 = rgb2gray(imread(files{2}));


%%


points1 = detectHarrisFeatures(img1);
points2 = detectHarrisFeatures(img2);

whos points1 points2

%%

[features1,valid_points1] = extractFeatures(img1,points1);
[features2,valid_points2] = extractFeatures(img2,points2); 
whos features1 features2 valid_points1 valid_points2

%%

[indexPairs,matchmetric] = matchFeatures(features1,features2);
whos indexPairs matchmetric

%%
% Retrieve the locations of the corresponding points for each image.

matchedPoints1 = valid_points1(indexPairs(:,1),:);
matchedPoints2 = valid_points2(indexPairs(:,2),:);


%%
%

figure(1); 
showMatchedFeatures(img1,img2,matchedPoints1,matchedPoints2,'Montage');
npts = size(matchedPoints1,1);
title([num2str(npts) ' Candidate point matches']);
legend('Matched points 1','Matched points 2');


%%

figure(2);
pts1 = double(matchedPoints1.Location);
show_points(img1,pts1);
pts2 = double(matchedPoints2.Location);


%%

[F, inliersIndex] = estimateFundamentalMatrix(pts1,pts2);
format shortg
F
format

dev = zeros(npts,1);
for k = 1:npts
    dev(k) = [pts2(k,1:2) 1]*F*[pts1(k,1:2) 1]';
end

ndx = 1:npts;
[ndx' inliersIndex dev]

%%

kdx = find(inliersIndex>0);
[mx, mdx]  = sort(abs(dev(kdx)),'descend');
n = kdx(mdx(1));
fprintf('number of inliers %d\n',length(kdx));
fprintf('maximum inlier dev(%d) = %g\n',n,abs(dev(n)))